package com.kongyu.project;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.content.Context;
import android.content.res.AssetManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Handler;
import android.util.TypedValue;
import android.view.MotionEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.viewpager.widget.PagerAdapter;
import androidx.viewpager.widget.ViewPager;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.xml.parsers.DocumentBuilderFactory;

public class MarqueeImageControl {
    static ViewPager viewPager;
    static ArrayList<ImageView> imageviews;
    static Activity context;
    // 图片资源
    static Hashtable<Integer, AdData> hsAd = new Hashtable<Integer, AdData>();
    static int preposition = 0;// 设置高亮的位置
    static Handler handler = new Handler() {
        public void handleMessage(android.os.Message msg) {
            int item = viewPager.getCurrentItem() + 1;
            viewPager.setCurrentItem(item);
            // 延迟发消息
            handler.sendEmptyMessageDelayed(0, 3000);
        }

        ;
    };
    static boolean isdragging = false;

    public static class AdData {
        public String Title;
        public String Url;
        public Bitmap image;

        public AdData(String Title, String Url, Bitmap image) {
            this.Title = Title;
            this.Url = Url;
            this.image = image;
        }
    }

    public static void show(final Activity context, int resid) {
        try {
            AssetManager assets = context.getAssets();
            //获取/assets/目录下所有文件
            String[] images = assets.list("pics");
            if (images == null) return;

            for (int i = 0; i < images.length; i++) {
                hsAd.put(i, new AdData("", "pics/" + images[i], null));
            }

            if (hsAd.size() <= 0)
                return;

            viewPager = new ViewPager(context);
            viewPager.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
            ViewGroup view = context.findViewById(resid);
            view.removeAllViews();
            view.addView(viewPager);

            context.runOnUiThread(new Runnable() {
                public void run() {
                    imageviews = new ArrayList<ImageView>();
                    for (int i = 0; i < hsAd.size(); i++) {
                        AdData adData = (AdData) hsAd.get(i);
                        ImageView imageview = new ImageView(context);

                        AssetManager assets = context.getAssets();
                        InputStream in = null;
                        try {
                            in = assets.open(adData.Url);
                            imageview.setImageBitmap(BitmapFactory.decodeStream(in));
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        imageview.setScaleType(ImageView.ScaleType.FIT_START);
                        imageview.setLayoutParams(new ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT));
                        imageviews.add(imageview);
                    }

                    viewPager.setAdapter(new Mypager());
                    viewPager.setOnPageChangeListener(new myon());
                    int item = Integer.MAX_VALUE / 2 - Integer.MAX_VALUE / 2 % imageviews.size();
                    viewPager.setCurrentItem(item);
                    handler.sendEmptyMessageDelayed(0, 3000);
                }
            });
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static class myon implements ViewPager.OnPageChangeListener {
        @Override
        public void onPageScrollStateChanged(int arg0) {
            if (arg0 == ViewPager.SCROLL_STATE_DRAGGING) {// 拖拽
                isdragging = true;

            } else if (arg0 == ViewPager.SCROLL_STATE_SETTLING) {// 滚动

            } else if (arg0 == ViewPager.SCROLL_STATE_IDLE && isdragging) {// 静止
                isdragging = false;
                handler.removeCallbacksAndMessages(null);
                handler.sendEmptyMessageDelayed(0, 3000);

            }
        }
        @Override
        public void onPageScrolled(int arg0, float arg1, int arg2) {

        }
        @Override
        public void onPageSelected(int arg0) {
            int realpostion = arg0 % imageviews.size();
            preposition = realpostion;
        }

    }

    public static class Mypager extends PagerAdapter {
        @Override
        public int getCount() {
            return Integer.MAX_VALUE;// int类型的最大值
        }

        @Override
        public Object instantiateItem(ViewGroup container, int position) {
            int realPostion = position % imageviews.size();
            final ImageView imageview = imageviews.get(realPostion);
            container.addView(imageview);// 添加到Viewpager中
            imageview.setOnTouchListener(new OnTouchListener() {

                @Override
                public boolean onTouch(View v, MotionEvent event) {
                    switch (event.getAction()) {
                        case MotionEvent.ACTION_DOWN:// 手指按下时的操作
                            handler.removeCallbacksAndMessages(null);
                            break;
                        case MotionEvent.ACTION_MOVE:// 手指移动时的操作
                            break;
                        case MotionEvent.ACTION_CANCEL:// 事件取消
                            handler.removeCallbacksAndMessages(null);
                            handler.sendEmptyMessageDelayed(0, 3000);
                            break;
                        case MotionEvent.ACTION_UP:// 手指抬起时的操作
                            handler.removeCallbacksAndMessages(null);
                            handler.sendEmptyMessageDelayed(0, 3000);
                            break;
                    }
                    return false;
                }
            });
            imageview.setTag(realPostion);
            return imageview;
        }

        @Override
        public boolean isViewFromObject(View arg0, Object arg1) {
            return arg0 == arg1;

        }

        @Override
        public void destroyItem(ViewGroup container, int position, Object object) {
            container.removeView((View) object);
        }
    }
}
